#define CTRL_2		0x0300
#define CTRL_6		0x071e

/* The control keys are wrong when not using Qwerty. Thankfully, they have
 * unique ASCII characters that can be used to identify them.
 */

#define CTRL_KEY(k) ((k)-'A'+1)
#define IS_CTRL_KEY(k,c)	(((k)&0x00ff) == CTRL_KEY(c))

#define CTRL_A		0x1e01
#define CTRL_B		0x3002
#define CTRL_C		0x2e03
#define CTRL_D		0x2004
#define CTRL_E		0x1205
#define CTRL_F		0x2106
#define CTRL_G		0x2207
#define CTRL_H		0x2308
#define CTRL_J		0x240a
#define CTRL_K		0x250b
#define CTRL_L		0x260c
#define CTRL_M		0x320d
#define CTRL_N		0x310e
#define CTRL_O		0x180f
#define CTRL_P		0x1910
#define CTRL_Q		0x1011
#define CTRL_R		0x1312
#define CTRL_S		0x1f13
#define CTRL_T		0x1414
#define CTRL_U		0x1615
#define CTRL_V		0x2f16
#define CTRL_W		0x1117
#define CTRL_X		0x2d18
#define CTRL_Y		0x1519
#define CTRL_Z		0x2c1a

#define ESCAPE		0x011b
#define ENTER		0x1c0d
#define MINUS		0x0c2d		/* Not keypad */
#define PAGEUP		0x4900
#define PAGEDOWN	0x5100
#define HOME		0x4700
#define END			0x4f00
#define INSERT		0x5200
#define DELETE		0x5300
#define CURS_UP		0x4800
#define CURS_DOWN	0x5000
#define CURS_LEFT	0x4b00
#define CURS_RIGHT	0x4d00
#define TAB			0x0f09

#define F1			0x3b00
#define F2			0x3c00
#define F3			0x3d00
#define F4			0x3e00
#define F5			0x3f00
#define F6			0x4000
#define F7			0x4100
#define F8			0x4200
#define F9			0x4300
#define F10			0x4400

#define SHIFT_F1	0x5400
#define SHIFT_F2	0x5500
#define SHIFT_F3	0x5600
#define SHIFT_F4	0x5700
#define SHIFT_F5	0x5800
#define SHIFT_F6	0x5900
#define SHIFT_F7	0x5a00
#define SHIFT_F8	0x5b00
#define SHIFT_F9	0x5c00
#define SHIFT_F10	0x5d00

#define KEY_C		0x2e63
#define KEY_E		0x1265
#define KEY_F		0x2166
#define KEY_L		0x266c
#define KEY_N		0x316e
#define KEY_O		0x186f
#define KEY_Q		0x1071
#define KEY_U		0x1675
#define KEY_V		0x2f76
#define KEY_W		0x1177

#define SHIFT_C		0x2e43
#define SHIFT_E		0x1245
#define SHIFT_F		0x2146

#define MOD_RSHIFT	0x01
#define MOD_LSHIFT	0x02
#define MOD_CTRL	0x04
#define MOD_ALT		0x08
#define MOD_SCROLL	0x10
#define MOD_NUMLOCK	0x20
#define MOD_CAPS	0x40
#define MOD_INSERT	0x80

#define MOD_SHIFT	(MOD_RSHIFT|MOD_LSHIFT)
